#include <gfxfont.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SPITFT.h>
#include <Adafruit_SPITFT_Macros.h>

//Huge thanks to the guys from adafruit for writing the 12c backpack code
/*************************************************** 
  This is a library for our I2C LED Backpacks

  Designed specifically to work with the Adafruit LED 7-Segment backpacks 
  ----> http://www.adafruit.com/products/881
  ----> http://www.adafruit.com/products/880
  ----> http://www.adafruit.com/products/879
  ----> http://www.adafruit.com/products/878

  These displays use I2C to communicate, 2 pins are required to 
  interface. There are multiple selectable I2C addresses. For backpacks
  with 2 Address Select pins: 0x70, 0x71, 0x72 or 0x73. For backpacks
  with 3 Address Select pins: 0x70 thru 0x77

  Adafruit invests time and resources providing this open source code, 
  please support Adafruit and open-source hardware by purchasing 
  products from Adafruit!

  Written by Limor Fried/Ladyada for Adafruit Industries.  
  BSD license, all text above must be included in any redistribution
 ****************************************************/

#include <Wire.h> // Enable this line if using Arduino Uno, Mega, etc.
#include <Adafruit_GFX.h>
#include "Adafruit_LEDBackpack.h"

int score = 0;
int m10 = 0;
int p20 = 0;
int p30 = 0;
int p50 = 0;
int ballout = 0;

int prev_m10 = 0;
int prev_p20 = 0;
int prev_p30 = 0;
int prev_p50 = 0;
int prev_ballout = 0;

const int m10_pin =       13;       // Change pin number here if desired - -10 points
const int p20_pin =       12;       // Change pin number here if desired -  20 points
const int p30_pin =       11;       // Change pin number here if desired -  30 points
const int p50_pin =       10;       // Change pin number here if desired -  50 points
const int ballout_pin =    9;       // Change pin number here if desired -  New ball

Adafruit_7segment matrix = Adafruit_7segment();

void setup() {

//================================  For the 7 segment display
#ifndef __AVR_ATtiny85__
  Serial.begin(9600);
  Serial.println("7 Segment Backpack Test");
#endif
  matrix.begin(0x70);

//================================  For the scoring system, declaring pins as input
  pinMode(m10_pin, INPUT);
  pinMode(p20_pin, INPUT);
  pinMode(p30_pin, INPUT);
  pinMode(p50_pin, INPUT);
  pinMode(ballout_pin, INPUT);

}

void loop() {

//================================  Start scoring system code

  m10 = digitalRead(m10_pin);
  p20 = digitalRead(p20_pin);
  p30 = digitalRead(p30_pin);
  p50 = digitalRead(p50_pin);
  ballout = digitalRead(ballout_pin);

  matrix.print(score);
  matrix.writeDisplay();
  
//================================  Points switches

  if (m10 != prev_m10) {
    if (m10 == HIGH) {
      score -= 10;                    // Change -10 points to other value here if desired
      matrix.print(score);
      matrix.writeDisplay();

      delay(50);
    }
    prev_m10 = m10;
  }

  else if (p20 != prev_p20) {
    if (p20 == HIGH) {
      score += 20;                    // Change 20 points to other value here if desired
      matrix.print(score);
      matrix.writeDisplay();

      delay(50);
    }
    prev_p20 = p20;
  }

  if (p30 != prev_p30) {
    if (p30 == HIGH) {
      score += 30;                    // Change 30 points to other value here if desired
      matrix.print(score);
      matrix.writeDisplay();

      delay(50);
    }
    prev_p30 = p30;
  }

  else if (p50 != prev_p50) {
    if (p50 == HIGH) {
      score += 50;                    // Change 50 points to other value here if desired
      matrix.print(score);
      matrix.writeDisplay();

      delay(50);
    }
    prev_p50 = p50;
  }
  
//================================  Ballout switch

  if (ballout != prev_ballout) {
    if (ballout == HIGH) {

      delay(50);
      score = 0;
    }
    prev_ballout = ballout;
  }



}


